Bug 827285 - [abrt] elfutils-0.153-1.fc16: report_r_debug: Process /usr/bin/eu-unstrip was killed by signal 11 (SIGSEGV)
[abrt] elfutils-0.153-1.fc16: report_r_debug: Process /usr/bin/eu-unstrip was...
Product: Fedora
Classification: Fedora
Component: elfutils (Show other bugs)
x86_64 Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: Petr Machata
Fedora Extras Quality Assurance
Depends On:
  Show dependency treegraph
Reported: 2012-05-31 23:06 EDT by mmolinac14
Modified: 2015-05-04 21:37 EDT (History)
5 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2013-02-13 16:23:43 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)
File: maps (4.90 KB, text/plain)
2012-05-31 23:06 EDT, mmolinac14
no flags Details
File: backtrace (60.25 KB, text/plain)
2012-05-31 23:07 EDT, mmolinac14
no flags Details

  None (edit)
Description mmolinac14 2012-05-31 23:06:48 EDT
libreport version: 2.0.8
abrt_version:   2.0.7
backtrace_rating: 4
cmdline:        eu-unstrip --core=./coredump -n
crash_function: report_r_debug
executable:     /usr/bin/eu-unstrip
kernel:         3.3.7-1.fc16.x86_64
pid:            5315
pwd:            /var/spool/abrt/ccpp-2012-05-31-23:04:12-5076
reason:         Process /usr/bin/eu-unstrip was killed by signal 11 (SIGSEGV)
time:           jue 31 may 2012 23:04:23 BOT
uid:            1000
username:       mmolinac

backtrace:      Text file, 61698 bytes
maps:           Text file, 5020 bytes


:/lib64/libdl-2.14.90.so glibc-2.14.90-24.fc16.7.x86_64 (Fedora Project) 1338236090
:/lib64/libpthread-2.14.90.so glibc-2.14.90-24.fc16.7.x86_64 (Fedora Project) 1338236090
:/usr/lib/locale/locale-archive glibc-common-2.14.90-24.fc16.7.x86_64 (Fedora Project) 1338236099
:/usr/lib64/liblzma.so.5.0.99 xz-libs-5.1.1-1alpha.fc16.x86_64 (Fedora Project) 1325481667
:/usr/bin/eu-unstrip elfutils-0.153-1.fc16.x86_64 (Fedora Project) 1331443932
:/lib64/libc-2.14.90.so glibc-2.14.90-24.fc16.7.x86_64 (Fedora Project) 1338236090
:/lib64/librt-2.14.90.so glibc-2.14.90-24.fc16.7.x86_64 (Fedora Project) 1338236090
:/usr/lib64/libdw-0.153.so elfutils-libs-0.153-1.fc16.x86_64 (Fedora Project) 1331443856
:/usr/lib64/libelf-0.153.so elfutils-libelf-0.153-1.fc16.x86_64 (Fedora Project) 1331443855
:/lib64/libbz2.so.1.0.6 bzip2-libs-1.0.6-3.fc15.x86_64 (Fedora Project) 1325481657
:/lib64/libgcc_s-4.6.3-20120306.so.1 libgcc-4.6.3-2.fc16.x86_64 (Fedora Project) 1335404602
:/lib64/libz.so.1.2.5 zlib-1.2.5-6.fc16.x86_64 (Fedora Project) 1329866819
:/lib64/ld-2.14.90.so glibc-2.14.90-24.fc16.7.x86_64 (Fedora Project) 1338236090


:UUID: 5b39f0b9-ccb2-4b53-8ae4-761a783b3269
:SO: Fedora release 16 (Verne)
:Nivel de ejecución por defecto: Unknown
:Idioma: es_ES.utf8
:Plataforma: x86_64
:BogoMIPS: 5223.78
:Fabricante de CPU: AuthenticAMD
:Modelo de CPU: AMD Athlon(tm) II X4 620 Processor
:Paso del UCP: 2
:Familia de UCP: 16
:Número de Modelo de CPU: 5
:Número de CPUs: 4
:Velocidad del CPU: 2600
:Memoria del Sistema: 2003
:Intercambio (swap) del Sistema: 4031
:Vendedor: System manufacturer
:Sistema: System Product Name System Version
:Factor de forma: Desktop
:Kernel: 3.3.7-1.fc16.x86_64
:SELinux Habilitado: 1
:Política de SELinux: targeted
:SELinux Obligado: Permissive
:MythTV Remote: Unknown
:MythTV Role: Unknown
:MythTV Theme: Unknown
:MythTV Plugin: 
:MythTV Tuner: -1
:(4318:1014:4163:33700) pci, sata_nv, STORAGE, MCP61 SATA Controller
:(4318:1004:4163:33700) pci, pata_amd, STORAGE, MCP61 IDE
:(4130:4611:0:0) pci, k10temp, HOST/PCI, Family 10h Processor Miscellaneous Control
:(4318:1000:4318:0) pci, pcieport, PCI/PCI, MCP61 PCI Express bridge
:(4318:1009:4163:33700) pci, ohci_hcd, USB, MCP61 USB Controller
:(4318:1010:4163:33700) pci, ehci_hcd, USB, MCP61 USB Controller
:(4130:4610:0:0) pci, None, HOST/PCI, Family 10h Processor DRAM Controller
:(4318:1001:4318:0) pci, pcieport, PCI/PCI, MCP61 PCI Express bridge
:(4130:4612:0:0) pci, None, HOST/PCI, Family 10h Processor Link Control
:(4130:4609:0:0) pci, None, HOST/PCI, Family 10h Processor Address Map
:(4130:4608:0:0) pci, None, HOST/PCI, Family 10h Processor HyperTransport Configuration
:(4318:1011:4163:33700) pci, None, PCI/PCI, MCP61 PCI bridge
:(4318:1007:4163:33700) pci, forcedeth, BRIDGE, MCP61 Ethernet
:(4318:1001:4318:0) pci, pcieport, PCI/PCI, MCP61 PCI Express bridge
:(4098:38226:5963:12288) pci, fglrx_pci, VIDEO, M92 LP [Mobility Radeon HD 4300 Series]
:(4318:994:4163:33700) pci, None, RAM, MCP61 LPC Bridge
:(4318:1008:4163:33663) pci, snd_hda_intel, MULTIMEDIA, MCP61 High Definition Audio
:(4098:43576:5963:43576) pci, snd_hda_intel, MULTIMEDIA, R700 Audio Device [Radeon HD 4000 Series]
:(4318:1013:4163:33700) pci, None, RAM, MCP61 Memory Controller
:(4318:1003:4163:33700) pci, nForce2_smbus, SERIAL, MCP61 SMBus
:(4318:993:4163:33700) pci, None, PCI/ISA, MCP61 LPC Bridge
:Información relacionada con el sistema de archivos
:device mtpt type bsize frsize blocks bfree bavail file ffree favail
:/dev/mapper/vg_cowboy-lv_root / ext4 4096 4096 13081819 8359606 7704246 3276800 2942821 2942821
:/dev/sdb2 /boot ext4 1024 1024 508745 105583 79983 128016 127776 127776
:/dev/mapper/vg_cowboy-lv_home /home ext4 4096 4096 63798936 54995154 51801503 15974400 15955092 15955092

:May 31 23:04:23 CowBoy kernel: [ 7559.341792] eu-unstrip[5315]: segfault at 8 ip 0000003ac9a24a34 sp 00007fff12898da0 error 4 in libdw-0.153.so[3ac9a00000+34000]
:May 31 23:04:24 CowBoy abrt[5316]: Saved core dump of pid 5315 (/usr/bin/eu-unstrip) to /var/spool/abrt/ccpp-2012-05-31-23:04:23-5315 (524288 bytes)
Comment 1 mmolinac14 2012-05-31 23:06:56 EDT
Created attachment 588254 [details]
File: maps
Comment 2 mmolinac14 2012-05-31 23:07:08 EDT
Created attachment 588256 [details]
File: backtrace
Comment 3 Petr Machata 2012-06-01 06:48:35 EDT
To original reporter: could you please upload /var/spool/abrt/ccpp-2012-05-31-23:04:12-5076/coredump, if it's still present?  This would make the following analysis simpler.
Comment 4 Petr Machata 2012-06-01 08:09:57 EDT
This is the fail site:

> lastmodp = &dwfl->modulelist;
> while (*lastmodp != mod) // here
>   lastmodp = &(*lastmodp)->next;

From the backtrace we know that:
> lastmodp = 0x8

So clearly "dwfl" is NULL.  But to get to report_r_debug we need non-zero r_debug_vaddr and I don't understand how this came to be.  It seems it should have failed one way or another.

Passed-in memory callback is 0x4, that's rubbish.  dwfl_link_map_report is called from dwfl_core_file_report, which passes dwfl_elf_phdr_memory_callback for that argument.  So let's assume that that's the actual value of memory callback.  This does cleanup and returns false if called with idx==-1, which would happen in situations like this:

>  /* NOTE: dwfl == NULL.  */
>  int phdr_segndx = INTUSE(dwfl_addrsegment) (dwfl, phdr, &phdr_mod);
>  if ((*memory_callback) (dwfl, phdr_segndx, &in.d_buf, &in.d_size,
>                          phdr, phnum * phent, memory_callback_arg))

To initialize r_debug_vaddr we would need to get either through find_executable, or consider_executable.  The former fails right away when called with dwfl == NULL.  The latter would be called with uninitialized phdr_mod, and would do all sorts of reads through that uninitialized pointer.  I just don't understand how it got through the maze and emerged on the other side with non-zero return value, so that report_r_debug can be called and fail the way we see.

I see a couple opportunities for making the code more robust, but I don't understand what's happening.  A core file would be needed I'm afraid.
Comment 5 Petr Machata 2012-06-03 09:17:32 EDT
To original reporter: could you please upload /var/spool/abrt/ccpp-2012-05-31-23:04:12-5076/coredump, if it's still present?  This would make the debugging simpler.
Comment 6 Fedora End Of Life 2013-01-16 12:02:24 EST
This message is a reminder that Fedora 16 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 16. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '16'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 16's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 16 is end of life. If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora, you are encouraged to click on 
"Clone This Bug" and open it against that version of Fedora.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
Comment 7 Fedora End Of Life 2013-02-13 16:23:47 EST
Fedora 16 changed to end-of-life (EOL) status on 2013-02-12. Fedora 16 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.